unit parsexmlmainu;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, ComCtrls, StdCtrls;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    OpenDialog1: TOpenDialog;
    Tree: TTreeView;
    procedure Button1Click(Sender: TObject);
  private

  public

  end;

var
  Form1: TForm1;

implementation
uses dom, xmlread;

{$R *.lfm}

{ TForm1 }

procedure TForm1.Button1Click(Sender: TObject);
var xml : TXMLDocument;

  procedure ParseXML(TreeParent : TTreeNode; Node : TDomNode);
  var TN : TTreeNode;
  begin
    while (Assigned(Node)) do
    begin
      TN := Tree.Items.AddChild(TreeParent, Node.NodeName + ' ' + Node.NodeValue);
      ParseXML(TN, Node.FirstChild); // Das ist der rekursive Aufruf
      Node := Node.NextSibling;
    end;
  end;

begin
  if OpenDialog1.Execute then
  begin
    ReadXMLFile(xml, OpenDialog1.Filename);
    ParseXML(nil, xml.FirstChild);
    xml.Free;
  end;
end;

end.

